/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.criteriaapiexample;

import com.jcg.model.Book;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class CriteriaAPIExample {

    public static void main(String[] args) {
        // Load configuration and build EntityManagerFactory
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");   
        
        // Obtain EntityManager and start transaction
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        
        // Create CriteriaBuilder and CriteriaQuery
        CriteriaBuilder criteriaBuilder = em.getCriteriaBuilder();
        CriteriaQuery<Book> criteriaQuery = criteriaBuilder.createQuery(Book.class);
        
        // Define the root of the query
        Root<Book> root = criteriaQuery.from(Book.class);
        criteriaQuery.select(root);
        
        // Execute the query and get the result list
        List<Book> bookList = em.createQuery(criteriaQuery).getResultList();
        
        // Print the result
        for (Book book : bookList) {
            System.out.println("Book ID: " + book.getId() + ", Title: " + book.getTitle() + ", Author: " + book.getAuthor());
        }
        
        // Commit transaction and close EntityManager
        em.getTransaction().commit();
        em.close();
        emf.close();
    }
}
