/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.fetchbookbytitle;

import java.util.List;
import com.jcg.model.Book;
import com.jcg.model.Review;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 *
 * @author omozegieaziegbe
 */
public class FetchBookByTitle {

    public static void main(String[] args) {
        // Load configuration and build EntityManagerFactory
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");

        // Obtain EntityManager and start transaction
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();

        try {
            // JPQL query to fetch book by title
            String jpql = "SELECT b FROM Book b WHERE b.title = :title";
            TypedQuery<Book> query = em.createQuery(jpql, Book.class);
            query.setParameter("title", "The Great Gatsby");

            // Get single result
            Book book = query.getSingleResult();

            // Print the book details
            System.out.println("Book ID: " + book.getId() + ", Title: " + book.getTitle() + ", Author: " + book.getAuthor());

            // Print the associated reviews
            List<Review> reviews = book.getReviews();
            for (Review review : reviews) {
                System.out.println("Review ID: " + review.getId() + ", Content: " + review.getContent());
            }

        } catch (Exception e) {
        } finally {
            // Commit transaction and close EntityManager
            em.getTransaction().commit();
            em.close();
            emf.close();
        }
    }
}
