/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.jpqlexample;

import com.jcg.model.Book;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 *
 * @author omozegieaziegbe
 */
public class JPQLExample {

    public static void main(String[] args) {
        
        // Load configuration and build EntityManagerFactory
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        
        // Obtain EntityManager and start transaction
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        
        // JPQL query to retrieve all books
        List<Book> bookList = em.createQuery("SELECT b FROM Book b", Book.class).getResultList();
        
        // Print the result
        for (Book book : bookList) {
            System.out.println("Book ID: " + book.getId() + ", Title: " + book.getTitle() + ", Author: " + book.getAuthor());
        }
        
        // Commit transaction and close EntityManager
        em.getTransaction().commit();
        em.close();
        emf.close();
    }
}
