/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.nativesqlexample;

import com.jcg.model.Book;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class NativeSQLExample {

    public static void main(String[] args) {
        // Load configuration and build EntityManagerFactory
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        
        // Obtain EntityManager and start transaction
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        
        // Native SQL query to retrieve all books
        List<Book> books = em.createNativeQuery("SELECT * FROM book").getResultList();
        
        // Print the result
        for (Book book : books) {
            System.out.println("Book ID: " + book.getId() + ", Title: " + book.getTitle() + ", Author: " + book.getAuthor());
        }
        
        // Commit transaction and close EntityManager
        em.getTransaction().commit();
        em.close();
        emf.close();
    }
}
